=== debian/changelog ===
nitrokey-app (1.3.2-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:20:42 +0100

nitrokey-app (1.3.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright: Update copyright infos for new upstream version.
  * debian/control:
    - Update to Debian policy 4.3.0, no changes needed.

 -- Jan Luca Naumann <j.naumann@fu-berlin.de>  Wed, 12 Dec 2018 13:24:37 +0100
