=== debian/control ===
Source: nitrokey-app
Section: utils
Priority: optional
Maintainer: Jan Luca Naumann <j.naumann@fu-berlin.de>
Build-Depends: bash-completion,
               cmake (>=3.1.0),
               debhelper (>= 11~),
               libgtk2.0-dev,
               libnotify-dev,
               libusb-1.0-0-dev,
               udev,
               qt5-qmake,
               qtbase5-dev,
               qttools5-dev,
               libqt5svg5-dev,
               qtchooser,
               libhidapi-dev,
               libnitrokey-dev (>=3.3)
Standards-Version: 4.3.0
Homepage: https://github.com/Nitrokey/nitrokey-app
Vcs-Git: https://salsa.debian.org/janluca-guest/nitrokey-app-debian.git
Vcs-Browser: https://salsa.debian.org/janluca-guest/nitrokey-app-debian

Package: nitrokey-app
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libccid, pcscd, scdaemon
Description: Application to manage the Nitrokey
 Nitrokey is an open source/open hardware USB key supporting
 secure encryption and signing. This package installs the
 official application to manage the features of the different
 USB keys.
