## nitrokey-app 1.4.1

=== debian/changelog ===
nitrokey-app (1.4.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    - Update to Debian policy 4.5.0, no changes needed.
    - Clean up Build-Depends. (Closes: #967655)
  * debian/compat: Update to compat version 13.

 -- Jan Luca Naumann <j.naumann@fu-berlin.de>  Thu, 06 Aug 2020 12:08:55 +0200

nitrokey-app (1.4.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/control:
    - Update to Debian policy 4.4.0, no changes needed.
  * debian/compat: Update to compat version 12.

 -- Jan Luca Naumann <j.naumann@fu-berlin.de>  Sat, 28 Sep 2019 18:25:48 +0200
