=== debian/control ===
--- 
+++ 
@@ -4,19 +4,18 @@
 Maintainer: Jan Luca Naumann <j.naumann@fu-berlin.de>
 Build-Depends: bash-completion,
                cmake (>=3.1.0),
-               debhelper (>= 11~),
-               libgtk2.0-dev,
-               libnotify-dev,
+               debhelper (>= 13~),
                libusb-1.0-0-dev,
                udev,
+               qtbase5-dev,
                qt5-qmake,
-               qtbase5-dev,
                qttools5-dev,
                libqt5svg5-dev,
-               qtchooser,
+               libqt5concurrent5,
                libhidapi-dev,
-               libnitrokey-dev (>=3.3)
-Standards-Version: 4.3.0
+               pkg-config,
+               libnitrokey-dev (>=3.5)
+Standards-Version: 4.5.0
 Homepage: https://github.com/Nitrokey/nitrokey-app
 Vcs-Git: https://salsa.debian.org/janluca-guest/nitrokey-app-debian.git
 Vcs-Browser: https://salsa.debian.org/janluca-guest/nitrokey-app-debian
