## nitrokey-app 1.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 cmake_policy(SET CMP0043 OLD) # cmake --help-policy CMP0043
 
 PROJECT(NitrokeyApp LANGUAGES CXX)
-SET(PROJECT_VERSION "1.3.2")
-set(LIBNK_MIN_VERSION 3.3)
+SET(PROJECT_VERSION "1.4.1")
+set(LIBNK_MIN_VERSION 3.5)
 
 include(GNUInstallDirs)
 
@@ -36,7 +36,7 @@
 
 #add CMake build info
 ADD_DEFINITIONS(-DCMAKE_BUILD_TYPE="${CMAKE_BUILD_TYPE}")
-ADD_DEFINITIONS(-DCMAKE_CXX_COMPILER="${CMAKE_CXX_COMPILER_ID}, ${CMAKE_CXX_COMPILER}, built on: ${CMAKE_SYSTEM} ")
+ADD_DEFINITIONS(-DCMAKE_CXX_COMPILER="${CMAKE_CXX_COMPILER_ID}, ${CMAKE_CXX_COMPILER}, built on: ${CMAKE_SYSTEM_NAME} ")
 ADD_DEFINITIONS(-DCMAKE_CXX_FLAGS="${CMAKE_CXX_FLAGS}")
