=== debian/changelog ===
nitrokey-app (1.4.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    - Update to Debian policy 4.5.1, no changes needed.

 -- Jan Luca Naumann <j.naumann@fu-berlin.de>  Mon, 08 Feb 2021 12:12:12 +0100
