=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
                libhidapi-dev,
                pkg-config,
                libnitrokey-dev (>=3.5)
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/Nitrokey/nitrokey-app
 Vcs-Git: https://salsa.debian.org/janluca-guest/nitrokey-app-debian.git
 Vcs-Browser: https://salsa.debian.org/janluca-guest/nitrokey-app-debian
