=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,buildinfo=+path
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT = qt5

%:
	dh $@ --with bash-completion

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release

override_dh_auto_install:
	dh_auto_install
	dh_install data/nitrokey-app-small.xpm usr/share/pixmaps
